; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
NrOfBalls    = 10;sets the number of balls
NrOfExplosions = 20
TVector struct
 _x dq ?
 _y dq ?
 _z dq ?
 _Static dd ?
dd ?
TVector ends
TRay struct
 _P TVector <> ;Any point on the line
 _V TVector <> ;Direction of the line
TRay ends
TColor struct
  red	dd ?
  green dd ?
  blue	dd ?
TColor ends
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
TEXTURE_IMAGE struct
	sizeX dd ?
	sizeY dd ?
	data_ dd ?
TEXTURE_IMAGE ends
; ,    
Explosion struct
	_Position TVector <>
	_Alpha dd ?
	_Scale dd ?
Explosion ends
;Plane structure
Plane struct
	_Position TVector <>
	_Normal TVector <>
Plane ends
;Cylinder structure
Cylinder struct
	_Position TVector <>
	_Axis TVector <>
	_Radius dq ?
Cylinder ends
INVALID = 0
DEFAULT = 1
UNIT    = 2
.data
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #30 - Magic Room",0
FileName	db "br_Rabbit3.cur",0
FileName0	dd offset FileName4,offset FileName3,offset FileName2,offset FileName1
FileName1	db "Marble.bmp",0
FileName2	db "Spark.bmp",0
FileName3	db "Boden.bmp",0
FileName4	db "Wand.bmp",0
FileName5	db "Explode.wav",0
FileName6	dd offset pl5, offset pl4,offset pl3,offset pl2,offset pl1
FileName7	dd offset cyl1, offset cyl2,offset cyl3
texture		dd ?,?,?,?
milliseconds    dd 10
;TimePoint	dd ?
Time2		dd ?
BallNr1		dd ?						
BallNr2         dd ?
spec		dd 3 dup(0),2.0;	sets specular highlight of balls
posl		dd   0,400.0,  0,1.0;	position of ligth source
amb		dd 3 dup(0.2), 1.0;	global ambient
amb2		dd 3 dup(0.3), 1.0;	ambient of lightsource
dir		TVector <0,0,-10.0>;	initial direction of camera
pos		TVector <0,-50.0,1000.0>;	initial position of camera
camera_rotation dd 0;	holds rotation around the Y axis
veloc		TVector <0.5,-0.1, 0.5>;	initial velocity of balls
;,    .   
accel		TVector <  0,-0.05, 0,DEFAULT>;	acceleration ie. gravity of balls
;,      
ArrayVel	TVector 10 dup (<0.5, -0.1,   0.5,DEFAULT>);	holds velocity of balls
;,      
ArrayPos	     TVector < 199.0,180.0,  10.0,DEFAULT>;	position of balls
		     TVector <     0,150.0, 100.0,DEFAULT>
  		     TVector <-100.0,180.0,-100.0,DEFAULT>
		     TVector <-275.0,300.0,-350.0,DEFAULT>
		     TVector <-200.0,300.0,-300.0,DEFAULT>
		     TVector <-125.0,300.0,-250.0,DEFAULT>
		     TVector < -50.0,300.0,-200.0,DEFAULT>
		     TVector <  25.0,300.0,-150.0,DEFAULT>
		     TVector < 100.0,300.0,-100.0,DEFAULT>
		     TVector < 175.0,300.0, -50.0,DEFAULT>
;,      
OldPos		TVector 10 dup (<>);	old position of balls
; ,     
ExplosionArray Explosion NrOfExplosions dup (<,0,1.0>)
; ,  
Time		dq 0.6;	timestep of simulation
hook_toball1	db 0;	hook camera on ball
sound		db 0; sound on/off
; ,    
pl1		label Plane 
		TVector <0,-300.0,0,DEFAULT>
		TVector <0,   1.0,0,DEFAULT>
pl2		label Plane
		TVector <300.0,0,0,DEFAULT>
		TVector <-1.0,0,0,DEFAULT>
pl3		label Plane 
		TVector <-300.0,0,0,DEFAULT>
		TVector <1.0,0,0,DEFAULT>
pl4		label Plane
		TVector <0,0,300.0,DEFAULT>
		TVector <0,0,-1.0,DEFAULT>
pl5		label Plane
		TVector <0,0,-300.0,DEFAULT>
		TVector <0,0,1.0,DEFAULT>
;,    
cyl1		label Cylinder 
		TVector <0,0,0,DEFAULT> ;_Position TVector
		TVector <0,1.0,0,DEFAULT> ;_Axis TVector
		dq 80.0;_Radius
cyl2		label Cylinder 
		TVector <200.0,-300.0,  0,DEFAULT> ;_Position TVector
		TVector <    0,     0,1.0,DEFAULT> ;_Axis TVector
		dq 80.0;_Radius
cyl3		label Cylinder 
		TVector <-200.0,  0,  0,DEFAULT> ;_Position TVector
		TVector <     0,1.0,1.0,DEFAULT> ;_Axis TVector
		dq 50.0;_Radius
dlist		dd ?
cylinder_obj	dq ?
hHeap		dq ?
colors	TColor <1.0,,>,<1.0,1.0,1.0>,<1.0,1.0,>,<,1.0,1.0>,<,1.0,>
        TColor <,,1.0>,<0.65,0.2,0.3>,<1.0,,1.0>,<,0.7,0.4>,<1.0,,>
;-----------------------------
BallColNr2	dd ?
BallColNr1	dd ?
RestTime	dq ?
BallTime	dq ?
Pos2		TVector <>
;-------------------------------
;float
const0_01       dd 0.01
const0_03	dd 0.03
const0_1	dd 0.1
const0_5	dd 0.5
const1		dd 1.0
const_1		dd -1.0
const10		dd 10.0
const40		dd 40.0
const_40	dd -40.0
const_45	dd -45.0
const50		dd 50.0
const_50	dd -50.0
const90		dd 90.0
const135	dd 135.0
const200	dd 200.0
const_200	dd -200.0
const_300	dd -300.0
const320	dd 320.0
const_320	dd -320.0
const360	dd 360.0
const_500	dd -500.0
;double
constd0_1	dq 0.1
constd0_5	dq 0.5
constd1		dq 1.0
constd10	dq 10.0
constd20	dq 20.0
constd30	dq 30.0
constd40	dq 40.0
constd50	dq 50.0
constd60	dq 60.0
constd150	dq 150.0
constd250	dq 250.0
constd1000	dq 1000.0
constd1700	dq 1700.0
constd10000	dq 10000.0
EPSILON		dq 10000.0
ZERO		dq 1.0e-8;0.00000001
_ZERO		dq -1.0e-8;-0.00000001
align 16
xmmword1 oword 80000000000000008000000000000000h
xmmword2 oword 7FFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFh
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
;---------------------------------------------------------------------
cross	proc arg_0:qword,arg_8:qword,arg_10:qword

	cmp	dword ptr[rcx].TVector._Static,INVALID
	jz	@f
	cmp	dword ptr[rdx].TVector._Static,INVALID
	jz	@f
	movsd	xmm0, qword ptr[rcx].TVector._y
	mulsd	xmm0, qword ptr[rdx].TVector._z
	movsd	xmm1, qword ptr[rcx].TVector._z
	mulsd	xmm1, qword ptr[rdx].TVector._y
	subsd	xmm0, xmm1
	movsd	qword ptr [r8].TVector._x,xmm0
	movsd	xmm0, qword ptr[rcx].TVector._z
	mulsd	xmm0, qword ptr[rdx].TVector._x
	movsd	xmm1, qword ptr[rcx].TVector._x
	mulsd	xmm1, qword ptr[rdx].TVector._z
	subsd	xmm0, xmm1
	movsd	qword ptr[r8].TVector._y,xmm0
	movsd	xmm0, qword ptr[rcx].TVector._x
	mulsd	xmm0, qword ptr[rdx].TVector._y
	movsd	xmm1, qword ptr[rcx].TVector._y
	mulsd	xmm1, qword ptr[rdx].TVector._x
	subsd	xmm0, xmm1
	movsd	qword ptr[r8].TVector._z,xmm0
	mov	dword ptr[r8].TVector._Static,DEFAULT
	jmp	@0
@@:	push	rdi
	mov	rdi,r8;arg_10
	xor	eax,eax
	mov	ecx,(sizeof TVector)/4
	rep	stosd
	pop	rdi
@0:	mov	rax,r8;arg_10
	leave
	retn
cross	endp
; ---------------------------------------------------------------------------
unit	proc 
	cmp	dword ptr [rcx].TVector._Static,DEFAULT
	jnz	exit_
	call	mag
	comisd	xmm0,ZERO
	ja	@f
	xorps	xmm0, xmm0
	movsd	[rcx].TVector._x,xmm0
	movsd	[rcx].TVector._y,xmm0
	movsd	[rcx].TVector._z,xmm0
	jmp	@0
@@:	movlhps	xmm0,xmm0
	movdqu	xmm1,[rcx]
	divpd	xmm1,xmm0; var_10
	movdqu	[rcx], xmm1
	movsd	xmm1,[rcx].TVector._z
	divsd	xmm1,xmm0; var_10
	movsd	[rcx].TVector._z,xmm1
@0:	mov	[rcx].TVector._Static,UNIT
exit_:	mov	eax,ecx
	retn
unit	endp
; ---------------------------------------------------------------------------
mag	proc
	cmp	dword ptr [rcx].TVector._Static,INVALID
	jz	@0
	cmp	dword ptr [rcx].TVector._Static,UNIT
	jnz	@f
	movsd	xmm0, constd1
	jmp	exit_
@@:	movdqu	xmm0,[rcx]
	mulpd	xmm0,xmm0
	movhlps	xmm1,xmm0
	addsd	xmm0,xmm1
	movsd	xmm1,qword ptr[rcx].TVector._z
	mulsd	xmm1,xmm1
	addsd	xmm0,xmm1
	sqrtsd	xmm0,xmm0
	jmp	exit_
@0:	xorps	xmm0,xmm0
exit_:	retn
mag	endp
; ---------------------------------------------------------------------------
dot	proc 
	cmp	dword ptr[rcx].TVector._Static,INVALID
	jz	@0
	cmp	dword ptr[rdx].TVector._Static,INVALID
	jz	@0
	movdqu	xmm0,[rcx]
	movdqu	xmm1,[rdx]
	mulpd	xmm0,xmm1
	movhlps	xmm1,xmm0
	addsd	xmm0,xmm1
	movsd	xmm1,qword ptr[rcx].TVector._z
	mulsd	xmm1,qword ptr[rdx].TVector._z; xmm0
	addsd	xmm0,xmm1
	jmp	@f
@0:	xorps	xmm0, xmm0
@@:	retn
dot	endp
; ---------------------------------------------------------------------------
multiply proc
local	old_edi:dword

	mov	old_edi,edi
	cmp	dword ptr [rcx].TVector._Static,INVALID
	jz	@0
	movlhps	xmm1,xmm1
	movdqu	xmm0,[rcx]
	mulpd	xmm0,xmm1
	movdqu	[r8], xmm0
	movsd	xmm0, qword ptr	[rcx].TVector._z
	mulsd	xmm0,xmm1
	movsd	qword ptr [r8].TVector._z, xmm0
	mov	dword ptr [r8].TVector._Static,DEFAULT
	jmp	@f
@0:	mov	edi,r8d
	xor	eax,eax
	mov	ecx,(sizeof TVector)/4
	rep	stosd
@@:	mov	eax,r8d
	mov	edi,old_edi
	leave
	retn
multiply endp
; ---------------------------------------------------------------------------
TestIntersionPlane proc	plane:qword,position:qword,direction:qword,lamda:qword,pNormal:qword
local	DotProduct:qword
local	l2:qword
local	temp:TVector
local	old_esi:dword
local	old_edi:dword

	mov	old_esi,esi
	mov	old_edi,edi

	mov	lamda,r9
	mov	direction,r8
	mov	position,rdx
	mov	plane,rcx

	mov	rdi, plane
	lea	edx,[rdi].Plane._Normal
	mov	rcx, direction
	call	dot
	movsd	DotProduct, xmm0;DotProduct=direction.dot(plane._Normal)
	comisd	xmm0,ZERO; if (DotProduct < ZERO)
	jnbe	@f
	comisd	xmm0,_ZERO; if (DotProduct > -ZERO)
	jnbe	exit0
; ---------------------------------------------------------------------------
@@:	mov	rdx,position
	lea	r8d,temp
	lea	ecx,[rdi].Plane._Position
	call	subtract;temp = plane._Position - position
	lea	edx,temp
	lea	ecx,[rdi].Plane._Normal
	call	dot;plane._Normal.dot(plane._Position-position)
	divsd	xmm0,DotProduct
	movsd	l2, xmm0;l2=(plane._Normal.dot(plane._Position-position))/DotProduct
	comisd	xmm0,_ZERO;
	jbe	exit0;if (l2 < -ZERO)
; ---------------------------------------------------------------------------
	lea	rsi,[rdi].Plane._Normal
	mov	rdi,pNormal
	mov	ecx,(sizeof TVector)/4
	rep	movsd;pNormal=plane._Normal
	mov	rax,lamda
	movsd	xmm0,l2
	movsd	qword ptr [rax], xmm0;lamda = l2
	mov	eax, 1
	jmp	@f
exit0:	xor	eax,eax	
@@:	mov	esi,old_esi
	mov	edi,old_edi
	leave
	retn
TestIntersionPlane endp
idle proc
local	BallNr:dword
local	rt4:qword
local	rt:qword
local	lamda:qword
local	rt2:qword
local	norm:TVector
local	uveloc:TVector
local	dummy:dword
local	normal_:TVector
local	point:TVector
local	temp0:qword
local	U2x:TVector
local	U1x:TVector
local	XAxis:TVector
local	Nc:TVector
local	pb2:TVector
local	pb1:TVector
local	U1y:TVector
local	V1x:TVector
local	V2y:TVector
local	V1y:TVector
local	V2x:TVector
local	U2y:TVector
local	temp1:TVector
local	temp:TVector

	and	BallNr, 0
	movsd	xmm0, Time
	movsd	RestTime, xmm0 ;RestTime=Time
;Compute velocity for next timestep using Euler equations
	xor	edi,edi
@@:	movsd	xmm1,RestTime
	lea	r8d,temp
	lea	rcx,accel
	call	multiply;temp = accel * RestTime
	lea	ecx,ArrayVel[rdi]
	lea	edx,temp
	mov	r8d,ecx
	call	addition;ArrayVel[j] += accel * RestTime
	add	edi,sizeof TVector
	cmp	edi,NrOfBalls*(sizeof TVector)
	jb	@b
;While timestep not over
@3:	movsd	xmm0, RestTime
	comisd	xmm0, ZERO;while (RestTime > ZERO)
	jbe	exit_
;initialize to very large value
	movsd	xmm0, constd10000
	movsd	lamda, xmm0;lamda=10000;   
;For all the balls find closest intersection between balls and planes/cylinders
	xor	edi,edi
;compute new position and distance
@4:	push	rdi
	lea	rsi,ArrayPos[rdi]
	lea	rdi,OldPos[rdi]
	mov	ecx,(sizeof TVector)/4
	rep	movsd ;OldPos[i] = ArrayPos[i]
	pop	rdi
;------------------------------------------------------------
	lea	esi,ArrayVel[rdi]
	lea	edx,uveloc
	push	rdi
	mov	edi,edx
	mov	ecx,(sizeof TVector)/4
	rep	movsd
	pop	rdi
	mov	ecx,edx
	call	unit;TVector::unit(ArrayVel[i],uveloc)
;------------------------------------------------------------
	movsd	xmm1,RestTime
	lea	ecx, ArrayVel[rdi]
	lea	r8d, temp
	call	multiply;temp = ArrayVel[i] * RestTime
	lea	ecx,ArrayPos[rdi]
	lea	edx,temp; rax
	lea	r8d,ArrayPos[rdi];temp
	call	addition;ArrayPos[i] = ArrayPos[i] + temp
	lea	edx, ArrayPos[rdi]
	lea	ecx, OldPos[rdi]
	call	dist
	movsd	rt2,xmm0;rt2 = OldPos[i].dist(ArrayPos[i])
;Test if collision occured between ball and all 5 planes
	mov	ebx,5	
@0:	lea	ecx,norm
	mov	[rsp+20h], rcx
	lea	r9d,rt
	lea	r8d,uveloc
	lea	edx,OldPos[rdi]
	mov	ecx,FileName6[rbx*4-4];offset pl1
	call	TestIntersionPlane
	test	eax, eax
	jz	@7
; Find intersection time
	movsd	xmm0, rt
	mulsd	xmm0, RestTime
	divsd	xmm0, rt2
	movsd	rt4,xmm0   ;rt4 = rt * RestTime/rt2
;if smaller than the one already stored replace and in timestep
	comisd	xmm0,lamda  ;if ( rt4 <= lamda )
	jnb	@7
	movsd	xmm1, RestTime
	addsd	xmm1, ZERO
	comisd	xmm1,xmm0 ;if ( rt4 <= RestTime + ZERO )
	jb	@7
	movsd	xmm0, ZERO
	comisd	xmm0, rt
	jb	@f
	lea	edx, norm
	lea	ecx, uveloc
	call	dot
	comisd	xmm0, ZERO
	ja	@7
@@:	push	rdi
	lea	edi, normal_
	lea	esi, norm
	mov	ecx,(sizeof TVector)/4
	rep	movsd	;normal = norm
	pop	rdi
	movsd	xmm1,rt
	lea	r8d,temp
	lea	ecx, uveloc
	call	multiply;temp = uveloc * rt
	lea	ecx, OldPos[rdi]
	lea	edx,temp
	lea	r8d,point;temp
	call	addition; ;point = OldPos[i] + uveloc * rt
	movsd	xmm0, rt4
	movsd	lamda, xmm0 ; lamda=rt4
	mov	BallNr,edi ;BallNr=i
@7:	dec	ebx
	jnz	@0

	mov	ebx,3
@1:	lea	edx, OldPos[rdi]
	lea	ecx, Nc
	mov	[rsp+28h], rcx
	lea	ecx, norm
	mov	[rsp+20h], rcx
	lea	r9d, rt
	lea	r8d, uveloc
	mov	ecx,FileName7[rbx*4-4]; cyl1
	call	TestIntersionCylinder
	test	eax, eax
	jz	@5
	movsd	xmm0, rt
	mulsd	xmm0, RestTime
	divsd	xmm0, rt2
	movsd	rt4,xmm0
	comisd	xmm0,lamda
	jnb	@5
	movsd	xmm1, RestTime
	addsd	xmm1, ZERO
	comisd	xmm1,xmm0; rt4
	jb	@5
	movsd	xmm0, ZERO
	comisd	xmm0, rt
	jb	@f
	lea	rdx, norm
	lea	rcx, uveloc
	call	dot
	comisd	xmm0, ZERO
	ja	@5

@@:	push	rdi
	lea	edi, normal_
	lea	esi, norm
	mov	ecx,(sizeof TVector)/4
	rep	movsd
	lea	edi, point
	lea	esi, Nc
	mov	ecx,(sizeof TVector)/4
	rep	movsd
	pop	rdi
	movsd	xmm0, rt4
	movsd	lamda, xmm0
	mov	BallNr,edi

@5:	dec	ebx
	jnz	@1
	add	edi,sizeof TVector
	cmp	edi,NrOfBalls*(sizeof TVector)
	jb	@4
; ---------------------------------------------------------------------------
	call	FindBallCol
	test	eax, eax
	jz	@8
	cmp	sound, 0
	jz	@f;if (sounds) PlaySound("Data/Explode.wav",NULL,SND_FILENAME|SND_ASYNC)
	mov	ecx,offset FileName5;"Explode.wav"
	invoke	PlaySound,,0,SND_FILENAME or SND_ASYNC
@@:	movsd	xmm0, lamda
	ucomisd	xmm0, constd10000
	jz	@f
	movsd	xmm0, lamda
	comisd	xmm0, BallTime
	jbe	@8
@@:	movsd	xmm0, RestTime
	subsd	xmm0, BallTime
	movsd	RestTime, xmm0
	mov	eax, BallColNr1
	lea	ecx, ArrayVel[rax]
	movsd	xmm1,BallTime
	lea	r8d,temp
	call	multiply
	mov	ecx, BallColNr1
	lea	ecx, OldPos[rcx]
	lea	edx,temp
	lea	r8d,pb1
	call	addition
	mov	eax,BallColNr2
	lea	ecx, ArrayVel[rax]
	movsd	xmm1,BallTime
	lea	r8d,temp
	call	multiply
	mov	ecx,BallColNr2
	lea	ecx, OldPos[rcx]
	lea	edx,temp
	lea	r8d,pb2 
	call	addition
	lea	edx, pb1
	lea	r8,temp
	lea	rcx, pb2
	call	subtract
	mov	rcx, rax
	call	unit
	lea	edi, XAxis
	mov	rsi, rax
	mov	ecx,(sizeof TVector)/4
	rep	movsd
	mov	eax,BallColNr1
	lea	edx, ArrayVel[rax]
	lea	ecx, XAxis
	call	dot
	movsd	xmm1, xmm0
	lea	r8d,U1x
	lea	ecx, XAxis
	call	multiply
	mov	eax,BallColNr1
	lea	ecx, ArrayVel[rax]
	lea	edx,U1x
	lea	r8d,U1y
	call	subtract
	lea	edx, pb2
	lea	r8d,temp
	lea	rcx, pb1
	call	subtract
	mov	ecx,eax
	call	unit
	lea	edi, XAxis
	mov	esi, eax
	mov	ecx,(sizeof TVector)/4
	rep	movsd
	mov	eax,BallColNr2
	lea	edx,ArrayVel[rax]
	lea	ecx,XAxis
	call	dot
	movsd	xmm1, xmm0
	lea	r8d,U2x
	lea	rcx, XAxis
	call	multiply
	mov	eax,BallColNr2
	lea	ecx, ArrayVel[rax]
	lea	edx, U2x
	lea	r8d,U2y
	call	subtract
	lea	edx, U2x
	lea	r8d,temp
	lea	rcx, U1x
	call	subtract
;--------------------------------------------------------------------------
	mov	temp0,rax
	lea	edx, U2x
	lea	r8d,temp
	lea	ecx, U1x
	call	addition
	mov	rdx,temp0
	lea	r8d,temp1
	lea	ecx,temp
	call	subtract
	movsd	xmm1,constd0_5
	lea	r8d,V1x
	lea	ecx,temp1
	call	multiply
	lea	edx, U1x
	lea	r8d,temp1
	lea	ecx, U2x
	call	subtract
	mov	temp0, rax
	lea	edx, U2x
	lea	r8d,temp1
	lea	ecx, U1x
	call	addition;
	mov	rdx,temp0
	lea	r8d,temp1
	mov	ecx,eax
	call	subtract
	movsd	xmm1,constd0_5
	lea	r8d,V2x
	mov	ecx,eax
	call	multiply
	lea	edi,V1y
	lea	esi,U1y
	mov	ecx,(sizeof TVector)/4
	rep	movsd;V1y = U1y
	lea	edi,V2y
	lea	esi,U2y
	mov	ecx,(sizeof TVector)/4
	rep	movsd;V2y = U2y
; ---------------------------------------------------------------------------
	xor	edi,edi
@@:	lea	ecx, ArrayVel[rdi]
	movsd	xmm1,BallTime
	lea	r8d,temp
	call	multiply;temp = ArrayVel[j] * BallTime
	lea	ecx, OldPos[rdi]
	lea	edx,temp
	lea	r8d,ArrayPos[rdi]
	call	addition;ArrayPos[j] = OldPos[j] + ArrayVel[j] * BallTime
	add	edi,(sizeof TVector)
	cmp	edi,NrOfBalls*(sizeof TVector)
	jb	@b
; ---------------------------------------------------------------------------
	mov	ecx,BallColNr1;,(sizeof TVector)
	lea	edx, V1y
	lea	r8d,ArrayVel[rcx]
	lea	rcx, V1x
	call	addition;ArrayVel[BallColNr1]=V1x+V1y
        mov	ecx,BallColNr2;,(sizeof TVector)
	lea	edx,V2y
	lea	r8d,ArrayVel[rcx]
	lea	ecx,V2x
	call	addition;ArrayVel[BallColNr2]=V2x+V2y
;Update explosion array
	xor	eax,eax
@@:	lea	rcx, ExplosionArray[rax]
	cmp	dword ptr[rcx].Explosion._Alpha,0;if ( ExplosionArray[j]._Alpha <= 0 )
	jg	@6
	movr	dword ptr[rcx].Explosion._Alpha,1.0;ExplosionArray[j]._Alpha=1
	mov	edi,ecx
	mov	ecx,BallColNr1;,(sizeof TVector)
	lea	esi, ArrayPos[rcx]
	mov	ecx,(sizeof TVector)/4
	rep	movsd;ExplosionArray[j]._Position=ArrayPos[BallColNr1]
	lea	ecx, ExplosionArray[rax]
	movr	dword ptr[rcx].Explosion._Scale,1.0;ExplosionArray[j]._Scale=1
	jmp	@3;break
@6:	add	eax,(sizeof Explosion)
	cmp	eax,NrOfExplosions*(sizeof Explosion)
	jb	@b
;End of tests 
;If test occured move simulation for the correct timestep
;and compute response for the colliding ball
@8:	movsd	xmm0, lamda
	ucomisd	xmm0, constd10000
	jz	exit_;if (lamda!=10000)
	movsd	xmm0, RestTime
	subsd	xmm0, lamda
	movsd	RestTime, xmm0;RestTime -= lamda
; ---------------------------------------------------------------------------
	xor	edi,edi
@@:	lea	ecx, ArrayVel[rdi]
	movsd	xmm1,lamda
	lea	r8d,temp
	call	multiply
	lea	edx,temp
	lea	ecx, OldPos[rdi]
	lea	r8d,ArrayPos[rdi]
	call	addition;	;ArrayPos[j] = OldPos[j] + ArrayVel[j] * lamda
	add	edi,(sizeof TVector)
	cmp	edi,NrOfBalls*(sizeof TVector)
	jb	@b
; ---------------------------------------------------------------------------
	mov	edi,BallNr
	lea	ecx,ArrayVel[rdi]
	call	mag;ArrayVel[BallNr].mag()
	movsd	rt2,xmm0;rt2 = ArrayVel[BallNr].mag()
	lea	ecx,ArrayVel[rdi]
	call	unit;ArrayVel[BallNr].unit()
	lea	ecx, ArrayVel[rdi]
	lea	edx,temp
	call	invert
	lea	edx,temp
	lea	rcx, normal_
	call	dot;xmm0 = normal.dot(-ArrayVel[BallNr])
	addsd	xmm0,xmm0;xmm0 = 2*normal.dot(-ArrayVel[BallNr])
	movsd	xmm1, xmm0
	lea	ecx, ArrayVel[rdi]
	mov	temp0, rcx
	lea	r8d,temp; T58
	lea	ecx, normal_
	call	multiply;normal*(2*normal.dot(-ArrayVel[BallNr]))
	mov	rcx,temp0
	mov	edx,ecx
	lea	r8d,temp1; T60
	mov	ecx,eax
	call	addition;(normal*(2*normal.dot(-ArrayVel[BallNr]))) + ArrayVel[BallNr]
	mov	edx,eax
	lea	ecx, ArrayVel[rdi]
	call	unit2;ArrayVel[BallNr]=TVector::unit( (normal*(2*normal.dot(-ArrayVel[BallNr]))) + ArrayVel[BallNr] )
	lea	ecx, ArrayVel[rdi]
	movsd	xmm1,rt2
	mov	r8d,ecx;lea	edx,ArrayVel[rax]
	call	multiply;ArrayVel[BallNr] = ArrayVel[BallNr] * rt2
;--------------------------------------------------
	xor	edx,edx
;Update explosion array
@@:	lea	eax, ExplosionArray[rdx]
	cmp	dword ptr[rax].Explosion._Alpha,0;if (ExplosionArray[j]._Alpha <= 0 )
	jg	@2
	movr	dword ptr [rax].Explosion._Scale,1.0
	mov	edi,eax;lea	edi, ExplosionArray._Position[rdx]
	lea	esi, point
	mov	ecx,(sizeof TVector)/4
	rep	movsd
	movr	dword ptr [rax].Explosion._Alpha,1.0
	jmp	@3
; ---------------------------------------------------------------------------
@2:	add	edx,sizeof Explosion
	cmp	edx,NrOfExplosions*(sizeof Explosion)
	jb	@b
	jmp	@3
; ---------------------------------------------------------------------------
exit_:	leave
	retn
idle endp
addition proc
local	old_edi:dword

	mov	old_edi,edi
	cmp	[rcx].TVector._Static,INVALID
	jz	@0
	cmp	[rdx].TVector._Static,INVALID
	jz	@0
	movdqu	xmm0,[rcx]
	movdqu	xmm1,[rdx]
	addpd	xmm0,xmm1
	movdqu	[r8],xmm0
	movsd	xmm0,[rcx].TVector._z
	addsd	xmm0,[rdx].TVector._z
	movsd	[r8].TVector._z,xmm0
	mov	[r8].TVector._Static,DEFAULT
        jmp	@f
@0:	mov	edi,r8d
	xor	eax,eax
	mov	ecx,(sizeof TVector)/4
	rep	stosd
@@:	mov	eax,r8d
	mov	edi,old_edi
	leave
	retn
addition endp
; ---------------------------------------------------------------------------
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	w:dword
local	h:dword
local	ps:PAINTSTRUCT
local	df_:dword
local	i:dword
local	unit_followvector:TVector
local	buff[10]:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN
        cmp	edx,WM_TIMER
	je      wmTIMER
	leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmTIMER:movss	xmm0,camera_rotation
	addss	xmm0,const0_1
	movss	camera_rotation,xmm0;camera_rotation+=0.1
	comiss	xmm0,const360
	jbe	@f;if (camera_rotation>360)
	and	camera_rotation,0;camera_rotation=0;
@@:     invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_UP
	jne	@f
	movsd	xmm0,pos.TVector._z
	subsd	xmm0,constd10
	movsd	pos.TVector._z,xmm0;	pos+=TVector(0,0,-10;
	jmp	@0
@@:    	cmp	al,VK_DOWN
	jne	@f
	movsd	xmm0,pos.TVector._z
	addsd	xmm0,constd10
	movsd	pos.TVector._z,xmm0;	pos+=TVector(0,0,10;
	jmp	@0
@@:    	cmp	al,VK_RIGHT
	jne	@f
	movss	xmm0,camera_rotation
	addss	xmm0,const10
	movss	camera_rotation,xmm0;	camera_rotation+=10;
	jmp	@0
@@:    	cmp	al,VK_LEFT
	jne	@f
	movss	xmm0,camera_rotation
	subss	xmm0,const10
	movss	camera_rotation,xmm0;	camera_rotation-=10;
	jmp	@0
@@:    	cmp	al,VK_ADD; "+"   
	jne	@f
	movsd	xmm0,Time
	addsd	xmm0,constd0_1
	movsd	Time,xmm0;	Time+=0.1;
	jmp	@0
@@:    	cmp	al,VK_SUBTRACT; "-"   
	jne	@f
	movsd	xmm0,Time
	subsd	xmm0,constd0_1
	movsd	Time,xmm0;	Time-=0.1;
	jmp	@0
@@:    	cmp	al,VK_F3
	jne	@f
	xor	sound,1;
	jmp	@0
@@:    	cmp	al,VK_F2
	jne	wmBYE
	xor	hook_toball1,1;
	and	camera_rotation,0;
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	mov	r8d,milliseconds
	invoke	SetTimer,hWin,10,,0;  #10  25mSec
;-------------------------------------------------------
; All Setup For OpenGL Goes Here
        invoke	GetProcessHeap
	mov	hHeap,rax
;create quadratic object to render cylinders
	invoke	gluNewQuadric
	mov	cylinder_obj,rax
	invoke	gluQuadricTexture,eax, GL_TRUE
	lea	ecx,cyl3._Axis
	invoke	unit;cyl3._Axis.unit();
	movr	df_,1000.0
        movq	xmm0,constd1
	invoke	glClearDepth; Depth Buffer Setup
	invoke	glEnable,GL_DEPTH_TEST; Enables Depth Testing
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing To Do
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Really Nice Perspective Calculations

	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor
	invoke	glMatrixMode,GL_MODELVIEW
	invoke	glLoadIdentity

	invoke	glShadeModel,GL_SMOOTH;
	invoke	glEnable,GL_CULL_FACE;
	invoke	glEnable,GL_DEPTH_TEST;

	mov	r8d,offset spec
	invoke	glMaterialfv,GL_FRONT,GL_SPECULAR
	lea	r8d,df_
	invoke	glMaterialfv,GL_FRONT,GL_SHININESS

	invoke	glEnable,GL_LIGHTING
	mov	r8d,offset posl
	invoke	glLightfv,GL_LIGHT0,GL_POSITION
	mov	r8d,offset amb2
	invoke	glLightfv,GL_LIGHT0,GL_AMBIENT
	invoke	glEnable,GL_LIGHT0;
	mov	edx,offset amb
	invoke	glLightModelfv,GL_LIGHT_MODEL_AMBIENT
	invoke	glEnable,GL_COLOR_MATERIAL
	invoke	glColorMaterial,GL_FRONT,GL_AMBIENT_AND_DIFFUSE
   
	invoke	glEnable,GL_BLEND;
	invoke	glBlendFunc,GL_SRC_ALPHA, GL_ONE;
   	
	invoke	glEnable,GL_TEXTURE_2D
	invoke	LoadGLTextures

;Construct billboarded explosion primitive as display list
;4 quads at right angles to each other
	invoke	glGenLists,1
	mov	dlist,eax
	invoke	glNewList,eax,GL_COMPILE;
	invoke	glBegin,GL_QUADS

	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,const_45
	invoke	glRotatef;(-45,0,1,0;
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f;(0,0,1;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f; 
	xorps	xmm2,xmm2
	movss	xmm1,const_40
	movss	xmm0,const_50
	invoke	glVertex3f;(-50,-40,0;
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f; 
	xorps	xmm2,xmm2
	movss	xmm1,const_40
	movss	xmm0,const50
	invoke	glVertex3f;(50,-40,0;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f; 
	xorps	xmm2,xmm2
	movss	xmm1,const40
	movss	xmm0,const50
	invoke	glVertex3f;(50,40,0;
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f; 
	xorps	xmm2,xmm2
	movss	xmm1,const40
	movss	xmm0,const_50
	invoke	glVertex3f;(-50,40,0;
	movss	xmm2,const_1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f;(0,0,-1;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f; 
	xorps	xmm2,xmm2
	movss	xmm1,const40
	movss	xmm0,const_50
	invoke	glVertex3f;(-50,40,0;
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f; 
	xorps	xmm2,xmm2
	movss	xmm1,const40
	movss	xmm0,const50
	invoke	glVertex3f;(50,40,0;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f; 
	xorps	xmm2,xmm2
	movss	xmm1,const_40
	movss	xmm0,const50
	invoke	glVertex3f;(50,-40,0;
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f; 
	xorps	xmm2,xmm2
	movss	xmm1,const_40
	movss	xmm0,const_50
	invoke	glVertex3f;(-50,-40,0;

	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glNormal3f;(1,0,0;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f; 
	movss	xmm2,const50
	movss	xmm1,const_40
	xorps	xmm0,xmm0
	invoke	glVertex3f;(0,-40,50;
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f; 
	movss	xmm2,const_50
	movss	xmm1,const_40
	xorps	xmm0,xmm0
	invoke	glVertex3f;(0,-40,-50;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f; 
	movss	xmm2,const_50
	movss	xmm1,const40
	xorps	xmm0,xmm0
	invoke	glVertex3f;(0,40,-50;
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f; 
	movss	xmm2,const50
	movss	xmm1,const40
	xorps	xmm0,xmm0
	invoke	glVertex3f;(0,40,50;
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const_1
	invoke	glNormal3f;(-1,0,0;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f; 
	movss	xmm2,const50
	movss	xmm1,const40
	xorps	xmm0,xmm0
	invoke	glVertex3f;(0,40,50;
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f; 
	movss	xmm2,const_50
	movss	xmm1,const40
	xorps	xmm0,xmm0
	invoke	glVertex3f;(0,40,-50;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f; 
	movss	xmm2,const_50
	movss	xmm1,const_40
	xorps	xmm0,xmm0
	invoke	glVertex3f;(0,-40,-50;
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f; 
	movss	xmm2,const50
	movss	xmm1,const_40
	xorps	xmm0,xmm0
	invoke	glVertex3f;(0,-40,50)
	invoke	glEnd
	invoke	glEndList
;--------------------------------------------------------
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0; Reset The Current Viewport

	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glLoadIdentity; Reset The Projection Matrix

; Calculate The Aspect Ratio Of The Window
	movq	xmm3,constd1700
	movq	xmm2,constd10
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd50
	invoke	gluPerspective

	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glLoadIdentity; Reset The Modelview Matrix

        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
	invoke	idle
	invoke	glMatrixMode,GL_MODELVIEW;
	invoke	glLoadIdentity
;set camera in hookmode
	and	qword ptr [rsp+40h],0;0
	mov	rax,constd1
	mov	[rsp+38h],rax;1
	and	qword ptr [rsp+30h],0;0 
	cmp	hook_toball1,0
	jz	@f
	mov	ecx,(sizeof TVector)/4
	mov	esi,offset ArrayVel[0*sizeof TVector]
	lea	edi,unit_followvector
	rep	movsd;TVector unit_followvector=ArrayVel[0];
	lea	ecx,unit_followvector
	invoke	unit;unit_followvector.unit()
	movsd	xmm0,ArrayPos[0]._z
	addsd	xmm0,ArrayVel[0]._z
	movsd	qword ptr [rsp+28h],xmm0;ArrayPos[0].Z()+ArrayVel[0].Z() 
	movsd	xmm0,ArrayPos[0]._y
	addsd	xmm0,ArrayVel[0]._y
	movsd	qword ptr [rsp+20h],xmm0;ArrayPos[0].Y()+ArrayVel[0].Y() 
	movsd	xmm3,ArrayPos[0]._x
	addsd	xmm3,ArrayVel[0]._x;ArrayPos[0].X()+ArrayVel[0].X() 
	movsd	xmm2,ArrayPos[0]._z;ArrayPos[0].Z() 
	movsd	xmm1,ArrayPos[0]._y
	addsd	xmm1,constd250;ArrayPos[0].Y()+250 
	movsd	xmm0,ArrayPos[0]._x
	addsd	xmm0,constd250;ArrayPos[0].X()+250
	jmp	@1
@@:	movsd	xmm0,pos._z
	addsd	xmm0,dir._z
	movsd	qword ptr [rsp+28h],xmm0;pos.Z()+dir.Z()
	movsd	xmm0,pos._y
	addsd	xmm0,dir._y
	movsd	qword ptr [rsp+20h],xmm0;,pos.Y()+dir.Y()
	movsd	xmm3,pos._x
	addsd	xmm3,dir._x;pos.X()+dir.X()
	movsd	xmm2,pos._z;pos.Z()
	movsd	xmm1,pos._y;pos.Y()
	movsd	xmm0,pos._x;pos.X()
@1:	invoke	gluLookAt		

	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;
        xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,camera_rotation
	invoke	glRotatef;camera_rotation,0,1,0;

;render balls
	mov	edi,(NrOfBalls-1)
@@:	imul	eax,edi,sizeof TColor
	movss	xmm2,colors[rax].blue
	movss	xmm1,colors[rax].green
	movss	xmm0,colors[rax].red
	invoke	glColor3f

	invoke	glPushMatrix;
	imul	eax,edi,sizeof TVector
	movsd	xmm2,ArrayPos[rax]._z
	movsd	xmm1,ArrayPos[rax]._y
	movsd	xmm0,ArrayPos[rax]._x
	invoke	glTranslated
	movq	xmm1,constd20
	invoke	gluSphere,cylinder_obj,,20,20
	invoke	glPopMatrix;
	dec	edi
	jns	@b
		
	invoke	glEnable,GL_TEXTURE_2D	
;render walls(planes) with texture
	mov	edx, texture[3*4]
	invoke	glBindTexture,GL_TEXTURE_2D;
	movss	xmm2,const1 
	movss	xmm1,xmm2
	movss	xmm0,xmm1
	invoke	glColor3f;(1, 1, 1);
	invoke	glBegin,GL_QUADS;
	xorps	xmm1,xmm1
	movss	xmm0,const1 
	invoke	glTexCoord2f;(1.0f, 0.0f); 
	movss	xmm2,const320 
	movss	xmm1,xmm2
	movss	xmm0,xmm1 
	invoke	glVertex3f;(320,320,320);
	movss	xmm1,const1 
	movss	xmm0,xmm1 
	invoke	glTexCoord2f;(1.0f, 1.0f); 
	movss	xmm2,const320 
	movss	xmm1,const_320  
	movss	xmm0,xmm2
	invoke	glVertex3f;(320,-320,320);
	movss	xmm1,const1 
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f); 
	movss	xmm2,const320 
	movss	xmm1,const_320
	movss	xmm0,xmm1 
	invoke	glVertex3f;(-320,-320,320);
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f); 
	movss	xmm2,const320 
	movss	xmm1,xmm2
	movss	xmm0,const_320
	invoke	glVertex3f;(-320,320,320);        
	xorps	xmm1,xmm1
	movss	xmm0,const1 
	invoke	glTexCoord2f;(1.0f, 0.0f); 
	movss	xmm2,const_320 
	movss	xmm1,const320
	movss	xmm0,xmm2
	invoke	glVertex3f;(-320,320,-320);
	movss	xmm1,const1 
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f); 
	movss	xmm2,const_320 
	movss	xmm1,xmm2
	movss	xmm0,xmm1
	invoke	glVertex3f;(-320,-320,-320);
	movss	xmm1,const1 
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f);
	movss	xmm2,const_320 
	movss	xmm1,xmm2
	movss	xmm0,const320 
	invoke	glVertex3f;(320,-320,-320);
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f); 
	movss	xmm2,const_320
	movss	xmm1,const320  
	movss	xmm0,xmm1
	invoke	glVertex3f;(320,320,-320);
	xorps	xmm1,xmm1
    	movss	xmm0,const1  
	invoke	glTexCoord2f;(1.0f, 0.0f); 
	movss	xmm2,const_320
	movss	xmm1,const320  
	movss	xmm0,xmm1
	invoke	glVertex3f;(320,320,-320);
	movss	xmm1,const1  
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f); 
	movss	xmm2,const_320
	movss	xmm1,xmm2
	movss	xmm0,const320  
	invoke	glVertex3f;(320,-320,-320);
    	movss	xmm1,const1  
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f); 
	movss	xmm2,const320
	movss	xmm1,const_320  
	movss	xmm0,xmm2
	invoke	glVertex3f;(320,-320,320);
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f); 
	movss	xmm2,const320  
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;(320,320,320);
	xorps	xmm1,xmm1
    	movss	xmm0,const1  	
	invoke	glTexCoord2f;(1.0f, 0.0f); 
	movss	xmm2,const320  
	movss	xmm1,xmm2
	movss	xmm0,const_320  
	invoke	glVertex3f;(-320,320,320);
    	movss	xmm1,const1  	
    	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f); 
	movss	xmm2,const320  
	movss	xmm1,const_320  
	movss	xmm0,xmm1
	invoke	glVertex3f;(-320,-320,320);
    	movss	xmm1,const1  	
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f); 
	movss	xmm2,const_320  
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;(-320,-320,-320);
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f); 
	movss	xmm2,const_320  
	movss	xmm1,const320  
	movss	xmm0,xmm2
	invoke	glVertex3f;(-320,320,-320);
	invoke	glEnd
;render floor (plane) with colours
	mov	edx, texture[2*4]
	invoke	glBindTexture,GL_TEXTURE_2D; 
	invoke	glBegin,GL_QUADS;
	xorps	xmm1,xmm1
    	movss	xmm0,const1  	
	invoke	glTexCoord2f;(1.0f, 0.0f); 
	movss	xmm2,const320  
	movss	xmm1,const_320  
	movss	xmm0,xmm1
	invoke	glVertex3f;(-320,-320,320);
    	movss	xmm1,const1  	
    	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f); 
	movss	xmm2,const320  
	movss	xmm1,const_320  
	movss	xmm0,xmm2
	invoke	glVertex3f;(320,-320,320);
    	movss	xmm1,const1  	
    	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f); 
	movss	xmm2,const_320  
	movss	xmm1,xmm2
	movss	xmm0,const320  
	invoke	glVertex3f;(320,-320,-320);
    	xorps	xmm1,xmm1
    	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f); 
	movss	xmm2,const_320  
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;(-320,-320,-320);
	invoke	glEnd
;render columns(cylinders)
	mov	edx, texture[0*4]
	invoke	glBindTexture,GL_TEXTURE_2D; choose the texture to use.
	movss	xmm2,const0_5
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor3f;(0.5,0.5,0.5);

	invoke	glPushMatrix
    	xorps	xmm3,xmm3
    	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,const90
	invoke	glRotatef;(90, 1,0,0);

	movss	xmm2,const_500
    	xorps	xmm1,xmm1
    	xorps	xmm0,xmm0
	invoke	glTranslatef;(0,0,-500);
	movq	xmm3,constd1000
	movq	xmm2,constd60
	movq	xmm1,xmm2
	invoke	gluCylinder,cylinder_obj,,,,20,2
	invoke	glPopMatrix

	invoke	glPushMatrix

	movss	xmm2,const_500
	movss	xmm1,const_300
	movss	xmm0,const200
	invoke	glTranslatef;(200,-300,-500);
	movq	xmm3,constd1000
	movq	xmm2,constd60
	movq	xmm1,xmm2
	invoke	gluCylinder,cylinder_obj,,,,20,2
	invoke	glPopMatrix

	invoke	glPushMatrix
    	xorps	xmm2,xmm2
    	xorps	xmm1,xmm1
	movss	xmm0,const_200
	invoke	glTranslatef;(-200,0,0);
    	xorps	xmm3,xmm3
    	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,const135
	invoke	glRotatef;(135, 1,0,0);

	movss	xmm2,const_500
    	xorps	xmm1,xmm1
    	xorps	xmm0,xmm0
	invoke	glTranslatef;(0,0,-500);
	movq	xmm3,constd1000
	movq	xmm2,constd30
	movq	xmm1,xmm2
	invoke	gluCylinder,cylinder_obj,,,,20,2
	invoke	glPopMatrix	
; /  
	invoke	glEnable,GL_BLEND ; 
	invoke	glDepthMask,GL_FALSE;   
	mov	edx, texture[1*4]   
	invoke	glBindTexture,GL_TEXTURE_2D; 
;   
	xor	edi,edi;	for(i=0; i<20; i++)
@3:	cmp	ExplosionArray[rdi]._Alpha,0
	jl	@f;if(ExplosionArray[i]._Alpha>=0)
	invoke	glPushMatrix
	movss	xmm0,ExplosionArray[rdi]._Alpha; 
	subss	xmm0,const0_01
	movss	ExplosionArray[rdi]._Alpha,xmm0;ExplosionArray[i]._Alpha-=0.01
	movss	xmm0,ExplosionArray[rdi]._Scale; 
        addss	xmm0,const0_03
	movss	ExplosionArray[rdi]._Scale,xmm0;ExplosionArray[i]._Scale+=0.03
;    
	movss	xmm3,ExplosionArray[rdi]._Alpha
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glColor4f;(1,1,0,ExplosionArray[i]._Alpha);	 
	movss	xmm2,ExplosionArray[rdi]._Scale
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glScalef;(ExplosionArray[i]._Scale,ExplosionArray[i]._Scale,ExplosionArray[i]._Scale);
;     
	cvtsd2ss xmm2,ExplosionArray[rdi]._Position._z
	divss	xmm2,ExplosionArray[rdi]._Scale
	cvtsd2ss xmm1,ExplosionArray[rdi]._Position._y
	divss	xmm1,ExplosionArray[rdi]._Scale
	cvtsd2ss xmm0,ExplosionArray[rdi]._Position._x
	divss	xmm0,ExplosionArray[rdi]._Scale
	invoke	glTranslatef;((float)ExplosionArray[i]._Position.X()/ExplosionArray[i]._Scale, (float)ExplosionArray[i]._Position.Y()/ExplosionArray[i]._Scale, (float)ExplosionArray[i]._Position.Z()/ExplosionArray[i]._Scale);
;  
	mov	ecx,dlist
	invoke	glCallList
	invoke	glPopMatrix
@@:	add	edi,sizeof Explosion
	cmp	edi,(sizeof Explosion)*NrOfExplosions
	jb	@3
	invoke	glDepthMask,GL_TRUE;
	invoke	glDisable,GL_BLEND;
	invoke	glDisable,GL_TEXTURE_2D
;--------------------------------------
        lea	edx,ps
	invoke	EndPaint,hWin
;   
        invoke	SwapBuffers,hDC
wmBYE:	leave
	retn	
WndProc	endp

LoadGLTextures proc
local	old_edi:dword
local	old_esi:dword
local	hFile:dword
local	FSize:dword
local	szReadWrite:dword	;number of bytes actually read or write
local	image[4]:qword
local	buff[20]:dword
	
	mov	old_edi,edi
	mov	old_esi,esi    
	mov	ebx,4
@@:	invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,sizeof TEXTURE_IMAGE
	mov	image[rbx*8-8],rax
; Load Image ************************************
	mov	esi,eax;image[rbx*8-8]
	mov	ecx,FileName0[rbx*4-4]
	xor	r8d,r8d
	mov	[rsp+30h],r8
	mov	qword ptr [rsp+28h],FILE_ATTRIBUTE_ARCHIVE
	mov	qword ptr [rsp+20h],OPEN_EXISTING
	invoke	CreateFile,,GENERIC_READ or GENERIC_WRITE,,0
	mov	hFile,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax
	mov	edi,eax
	and	qword ptr [rsp+20h],0
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize
        invoke	CloseHandle,hFile
        mov	eax,edi
        add	eax,[rdi + BITMAPFILEHEADER.bfOffBits]
	mov	[rsi].TEXTURE_IMAGE.data_,eax
        lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	[rsi].TEXTURE_IMAGE.sizeX,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	[rsi].TEXTURE_IMAGE.sizeY,eax
	dec	ebx
	jnz	@b
; Create texture ****************************************
	mov	edx,offset texture
	invoke	glGenTextures,2
	mov	edx, texture[0*4]
	invoke	glBindTexture,GL_TEXTURE_2D; 2d texture (x and y size)

	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR;  scale linearly when image bigger than texture
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR;  scale linearly when image smalled than texture
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_REPEAT;
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_REPEAT;

; 2d texture, level of detail 0 (normal), 3 components (red, green, blue), x size from image, y size from image, 
; border 0 (normal), rgb color data, unsigned byte data, and finally the data itself.
	xor	edx,edx
	mov	rcx,image[3*8]
	mov	r9d,[rcx].TEXTURE_IMAGE.sizeX
	mov	eax,[rcx].TEXTURE_IMAGE.sizeY
	mov	[rsp+20h],rax
	mov	[rsp+28h],rdx
	mov	eax,[rcx].TEXTURE_IMAGE.data_
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D,,3,,,, GL_BGR, GL_UNSIGNED_BYTE
; Create Texture	*****************************************
	mov	edx, texture[1*4]
	invoke	glBindTexture,GL_TEXTURE_2D;    2d texture (x and y size)

	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR;  scale linearly when image bigger than texture
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR;  scale linearly when image smalled than texture
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_REPEAT
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_REPEAT
; 2d texture, level of detail 0 (normal), 3 components (red, green, blue), x size from image, y size from image, 
; border 0 (normal), rgb color data, unsigned byte data, and finally the data itself.
	xor	edx,edx
	mov	rcx,image[2*8]
	mov	r9d,[rcx].TEXTURE_IMAGE.sizeX
	mov	eax,[rcx].TEXTURE_IMAGE.sizeY
	mov	[rsp+20h],rax
	mov	[rsp+28h],rdx
	mov	eax,[rcx].TEXTURE_IMAGE.data_
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D,,3,,,, GL_BGR, GL_UNSIGNED_BYTE
; Create Texture	*******************************************
	mov	edx,offset texture[2*4]
	invoke	glGenTextures,2
	mov	edx, texture[2*4]
	invoke	glBindTexture,GL_TEXTURE_2D;    2d texture (x and y size)

	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR;  scale linearly when image bigger than texture
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR;  scale linearly when image smalled than texture
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_REPEAT
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_REPEAT

; 2d texture, level of detail 0 (normal), 3 components (red, green, blue), x size from image, y size from image, 
; border 0 (normal), rgb color data, unsigned byte data, and finally the data itself.
	xor	edx,edx
	mov	rcx,image[1*8]
	mov	r9d,[rcx].TEXTURE_IMAGE.sizeX
	mov	eax,[rcx].TEXTURE_IMAGE.sizeY
	mov	[rsp+20h],rax
	mov	[rsp+28h],rdx
	mov	eax,[rcx].TEXTURE_IMAGE.data_
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D,,3,,,, GL_BGR, GL_UNSIGNED_BYTE
; Create Texture	********************************************
	mov	edx, texture[3*4]
	invoke	glBindTexture,GL_TEXTURE_2D;    2d texture (x and y size)

	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR;  scale linearly when image bigger than texture
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR;  scale linearly when image smalled than texture
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_REPEAT
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_REPEAT

; 2d texture, level of detail 0 (normal), 3 components (red, green, blue), x size from image, y size from image, 
; border 0 (normal), rgb color data, unsigned byte data, and finally the data itself.
	xor	edx,edx
	mov	rcx,image[0*8]
	mov	r9d,[rcx].TEXTURE_IMAGE.sizeX
	mov	eax,[rcx].TEXTURE_IMAGE.sizeY
	mov	[rsp+20h],rax
	mov	[rsp+28h],rdx
	mov	eax,[rcx].TEXTURE_IMAGE.data_
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D,,3,,,,GL_BGR,GL_UNSIGNED_BYTE
;	mov	edi,3
;@@:	mov	rax,image[rdi*8]
;	mov	r8d,[rax].TEXTURE_IMAGE.data_
;	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY
;	mov	r8,image[rdi*8]
;	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY
;	dec	edi
;	jns	@b
	mov	edi,old_edi
	mov	esi,old_esi    
	leave
	ret
LoadGLTextures endp
;---------------------------------------------------------------
subtract proc ;arg_0:qword,arg_8:qword,arg_10:qword
	cmp	dword ptr [rcx].TVector._Static,INVALID
	jz	@f
	cmp	dword ptr [rdx].TVector._Static,INVALID
	jz	@f
	movdqu	xmm0,[rcx]
	movdqu	xmm1,[rdx]
	subpd	xmm0,xmm1
	movdqu	[r8],xmm0
	movsd	xmm0, qword ptr	[rcx].TVector._z
	subsd	xmm0, qword ptr	[rdx].TVector._z
	movsd	qword ptr [r8].TVector._z, xmm0
	mov	dword ptr [r8].TVector._Static,DEFAULT; 1
@@:	mov	eax,r8d
	retn
subtract	endp
; ---------------------------------------------------------------------------
dist	proc arg_0:qword,arg_8:qword
local	var_28:TVector

	mov	arg_8, rdx
	mov	arg_0, rcx
	mov	rdx,arg_8
	lea	r8d,var_28
	mov	rcx,arg_0
	call	subtract
	mov	rcx, rax
	call	mag
	leave
	retn
dist	endp
; ---------------------------------------------------------------------------
TestIntersionCylinder proc cylinder:qword,position:qword,direction:qword,lamda:qword,pNormal:qword,newposition:qword
local	out_:qword
local	in_:qword
local	d:qword
local	ln:qword
local	t:qword
local	temp0:qword
local	n:TVector
local	O:TVector
local	RC:TVector
local	HB:TVector
local	D:TVector
local	temp:TVector
local	old_esi:dword
local	old_edi:dword

	mov	old_esi,esi
	mov	old_edi,edi

	mov	lamda,r9
	mov	direction,r8
	mov	position,rdx
	mov	cylinder,rcx

	mov	rdi, cylinder
	lea	r8, RC
	mov	rcx, position
	lea	edx,[rdi].Cylinder._Position
	call	subtract;TVector::subtract(position,cylinder._Position,RC)
	lea	r8, n
	lea	edx,[rdi].Cylinder._Axis
	mov	rcx,direction
	call	cross;TVector::cross(direction,cylinder._Axis,n)
	lea	rcx, n
	call	mag
	movsd	ln, xmm0;ln=n.mag()
	comisd	xmm0,ZERO; ln
	jnbe	@f
	comisd	xmm0, _ZERO
	jnbe	exit0
; ---------------------------------------------------------------------------
@@:	lea	rcx, n
	call	unit ;n.unit()
	lea	rdx, n
	lea	rcx, RC
	call	dot
	andps	xmm0,xmmword2
	movsd	d, xmm0 ;d= abs( RC.dot(n) )
	comisd	xmm0,qword ptr[rdi].Cylinder._Radius; if (d <= cylinder._Radius)
	jnb	exit0
	lea	r8, O
	lea	edx,[rdi].Cylinder._Axis
	lea	rcx, RC
	call	cross;TVector::cross(RC,cylinder._Axis,O)
	lea	rdx, n
	lea	rcx, O
	call	dot;xmm0 = O.dot(n)
	xorps	xmm0,xmmword1;xmm0 = -O.dot(n)
	divsd	xmm0,ln
	movsd	t,xmm0;t = -O.dot(n)/ln
	lea	r8, O
	lea	edx,[rdi].Cylinder._Axis
	lea	rcx, n
	call	cross;TVector::cross(n,cylinder._Axis,O)
	lea	rcx, O
	call	unit;O.unit()
	movsd	xmm0, qword ptr[rdi].Cylinder._Radius
	mulsd	xmm0,xmm0; qword ptr	[rcx+40h]
	movsd	xmm1, d
	mulsd	xmm1,xmm1;xmm1 = d*d
	subsd	xmm0, xmm1
	sqrtsd	xmm0,xmm0
	movsd	temp0, xmm0
	lea	rdx, O
	mov	rcx, direction
	call	dot
	movsd	xmm1, temp0
	divsd	xmm1, xmm0
	andps	xmm1,xmmword2
	movsd	xmm0,t
	subsd	xmm0,xmm1;s
	movsd	in_,xmm0
	movsd	xmm0,t
	addsd	xmm0,xmm1;s
	movsd	out_, xmm0
	movsd	xmm0, _ZERO
	comisd	xmm0, in_
	jbe	@f
	comisd	xmm0, out_
	jnbe	exit0
	movsd	xmm1, out_
	jmp	@0
; ---------------------------------------------------------------------------
@@:	movsd	xmm0, _ZERO
	comisd	xmm0, out_
	jbe	@f
	movsd	xmm1, in_
	jmp	@0
; ---------------------------------------------------------------------------
@@:	movsd	xmm1, out_
	comisd	xmm1, in_
	jbe	@0
	movsd	xmm1, in_
	jmp	@0
; ---------------------------------------------------------------------------
@0:	mov	rdx,lamda
	movsd	qword ptr [rdx],xmm1
	lea	r8d,temp
	mov	rcx, direction
	call	multiply;temp = direction*lamda
	lea	edx,temp
	mov	r8,newposition
	mov	rcx, position
	call	addition;newposition = position + direction * lamda
	lea	edx,[rdi].Cylinder._Position
	lea	r8d, HB
	mov	rcx, newposition
	call	subtract;TVector HB = newposition - cylinder._Position
	lea	edx,[rdi].Cylinder._Axis
	lea	rcx, HB
	call	dot
	movsd	xmm1, xmm0;xmm1 = HB.dot(cylinder._Axis)
	lea	r8d,temp
	lea	ecx,[rdi].Cylinder._Axis
	call	multiply;temp = cylinder._Axis*(HB.dot(cylinder._Axis)
	lea	edx,temp
	mov	r8,pNormal; T6
	lea	rcx, HB
	call	subtract;
	mov	rcx, pNormal
	call	unit
	mov	eax, 1
	jmp	@f
exit0:	xor	eax, eax
@@:	mov	esi,old_esi
	mov	edi,old_edi
	leave
	retn
TestIntersionCylinder endp
; ---------------------------------------------------------------------------
FindBallCol proc
local	MyTime:qword
local	Timedummy:qword
local	Add_:qword
local	RelativeV:TVector
local	posi:TVector
local	rays:TRay
local	var_D8:TVector
local	temp:TVector	

	push	rdi
	push	rsi
	movsd	xmm0,RestTime
	divsd	xmm0,constd150
	movsd	Add_,xmm0
	movsd	xmm0,constd10000
	movsd	Timedummy, xmm0
; ---------------------------------------------------------------------------
	xor	edi,edi
@0:	mov	esi,edi
	add	esi,sizeof TVector
; ---------------------------------------------------------------------------
@1:	add	esi,sizeof TVector
	cmp	esi,NrOfBalls*(sizeof TVector)
	jge	@3
	lea	edx, ArrayVel[rsi]
	lea	ecx, ArrayVel[rdi]
	lea	r8d,RelativeV
	call	subtract;RelativeV = ArrayVel[i] - ArrayVel[j]
	lea	rdx, RelativeV
	lea	rcx, var_D8
	call	unit2;TVector::unit(RelativeV)
	lea	edx, OldPos[rdi]
	mov	r8, rax
	lea	rcx,rays; var_58
	call	TRay_;rays=TRay(OldPos[i],TVector::unit(RelativeV))
	xor	eax,eax
	mov	MyTime,rax;MyTime=0.0
	lea	edx, OldPos[rsi]
	lea	rcx, rays
	call	TRay_dist;rays.dist(OldPos[j]))
	comisd	xmm0, constd40
	jnbe	@1;if ( (rays.dist(OldPos[j])) > 40) continue
; ---------------------------------------------------------------------------
@2:	movsd	xmm0, RestTime
	comisd	xmm0, MyTime
	jbe	@1
	movsd	xmm1, MyTime
	addsd	xmm1, Add_
	movsd	MyTime, xmm1
	lea	r8d, temp
	lea	rcx, RelativeV
	call	multiply;temp = RelativeV * MyTime
	lea	ecx, OldPos[rdi]
	lea	edx,temp
	lea	r8d,posi
	call	addition;posi=OldPos[i]+RelativeV*MyTime
	lea	edx, OldPos[rsi]
	lea	rcx, posi
	call	dist;posi.dist(OldPos[j])
	comisd	xmm0, constd40
	jnb	@2;if ( posi.dist(OldPos[j]) <= 40 ) 
	push	rdi
	push	rsi
	lea	esi,posi
	mov	edi,offset Pos2
	mov	ecx,(sizeof TVector)/4
	rep	movsd;point=posi
	pop	rsi
	pop	rdi
	movsd	xmm0, MyTime
	subsd	xmm0, Add_
	comisd	xmm0, Timedummy
	jnbe	@f
	movsd	Timedummy, xmm0;if (Timedummy>(MyTime-Add)) Timedummy=MyTime-Add
@@:	mov	BallColNr1,edi
	mov	BallColNr2,esi
	jmp	@1
; ---------------------------------------------------------------------------
@3:	add	edi,(sizeof TVector)
	cmp	edi,(NrOfBalls-1)*(sizeof TVector)
	jb	@0
; ---------------------------------------------------------------------------
	movsd	xmm0, Timedummy
	ucomisd	xmm0, constd10000
	jz	exit0
@@:	movsd	xmm0, Timedummy
	movsd	BallTime, xmm0
	mov	eax, 1
	jmp	@f
exit0:	xor	eax, eax
@@:	pop	rsi
	pop	rdi
	leave
	retn
FindBallCol	endp
; ---------------------------------------------------------------------------
;static TVector &unit(const TVector &v, TVector &result) { result = v; return result.unit(); }
unit2	proc v_:qword,result:qword
local	temp:TVector
local	old_esi:dword
local	old_edi:dword

	mov	old_esi,esi
	mov	old_edi,edi

	mov	result,rdx
	mov	v_,rcx
	lea	edi,temp
	mov	esi,edx
	mov	ecx,(sizeof TVector)/4
	rep	movsd;temp = result
	lea	rcx, temp
	call	unit;temp.unit()
	mov	rdi,v_
	mov	esi,eax
	mov	ecx,(sizeof TVector)/4
	rep	movsd
	mov	rax,v_
	mov	esi,old_esi
	mov	edi,old_edi
	leave
	retn
unit2	endp
;TRay::TRay(const TVector &point1, const TVector &point2)
;: _P(point1) {
;	_V = (point2.isUnit() ? point2 : TVector::unit(point2-point1));
;------------------------------------------------------------
TRay_	proc ray:qword,point1:qword,point2:qword
local	_V:TVector
local	temp:TVector
local	old_esi:dword
local	old_edi:dword

	mov	old_esi,esi
	mov	old_edi,edi

	mov	point2, r8
	mov	point1, rdx
	mov	ray, rcx
	mov	edi,ecx; arg_0
	mov	rsi, point1
	mov	ecx,(sizeof TVector)/4
	rep	movsd
	mov	rcx, point2
	cmp	dword ptr [rcx].TVector._Static,UNIT;point2.isUnit()
	jnz	@f
	lea	edi,_V
	mov	rsi,point2
	mov	ecx,(sizeof TVector)/4
	rep	movsd;_V = point2
	lea	eax,_V
	jmp	@0
@@:	mov	rdx, point1
	lea	r8d,temp
	call	subtract;temp = point2-point1
	mov	edx, eax
	lea	ecx, temp
	call	unit2;TVector::unit(point2-point1))

@0:	mov	rcx, ray
	lea	edi,[rcx].TRay._V
	mov	esi,eax
	mov	ecx,(sizeof TVector)/4
	rep	movsd

	mov	rax, ray
	mov	esi,old_esi
	mov	edi,old_edi
	leave
	retn
TRay_	endp
; ---------------------------------------------------------------------------
;Distance between a ray and a point
;double TRay::dist(const TVector &point) const {
;	if (isValid() && point.isValid()) {
;		TVector tv, point2;
;		double lambda = TVector::dot(_V, point-_P);
;		TVector::add(_P, TVector::multiply(_V, lambda, tv), point2);
;		return point.dist(point2);
;	}
;	return 0.0;
;}
;TRay struct
; _P TVector <> ;Any point on the line
; _V TVector <> ;Direction of the line
;TRay ends
;---------------------------------------------
TRay_dist proc ray:qword,point:qword
local	point2:TVector
local	tv:TVector
local	temp:TVector

	mov	point, rdx
	mov	ray, rcx
	cmp	dword ptr [rcx].TRay._V._Static,UNIT;V().isUnit()
	jnz	@0
	cmp	dword ptr [rcx].TRay._P._Static,INVALID;P().isValid()
	jz	@0
	mov	rcx, point
	cmp	dword ptr [rcx].TVector._Static,INVALID;point.isValid()
	jz	@0
	mov	rdx,ray;eax
	lea	edx,[rdx].TRay._P
	lea	r8d, temp
	mov	rcx, point
	call	subtract;temp = point-ray._P
	mov	rcx, ray
	lea	ecx,[rcx].TRay._V
	lea	edx,temp
	call	dot;lambda = TVector::dot(ray._V, point-ray._P)
	movsd	xmm1, xmm0
	mov	rcx, ray
	lea	ecx,[rcx].TRay._V
	lea	r8, tv
	call	multiply;tv = ray._V * lambda
	mov	rcx, ray
	lea	ecx,[rcx].TRay._P
	lea	r8d,point2
	mov	edx,eax
	call	addition;point2 = ray._P + tv
	lea	edx,point2
	mov	rcx,point
	call	dist;point.dist(point2)
	jmp	@f
; ---------------------------------------------------------------------------
@0:	xorps	xmm0, xmm0
@@:	leave
	retn
TRay_dist endp
; ---------------------------------------------------------------------------
invert	proc arg_0:qword,arg_8:qword
local	old_edi:dword

	mov	old_edi,edi
	cmp	dword ptr [rcx].TVector._Static,INVALID
	jz	@0
	movdqu	xmm0,[rcx]
	movdqa	xmm1,xmmword1
	xorpd	xmm0,xmm1
	movdqu	[rdx],xmm0
	movsd	xmm0, qword ptr	[rcx].TVector._z
	xorps	xmm0,xmm1
	movsd	qword ptr [rdx].TVector._z, xmm0
	mov	eax, [rcx].TVector._Static
	mov	[rdx].TVector._Static, eax
	jmp	@f
; ---------------------------------------------------------------------------
@0:	mov	edi,edx
	xor	eax,eax
	mov	ecx,(sizeof TVector)/4
	rep	stosd
@@:	mov	eax,edx
	mov	edi,old_edi
	leave
	retn
invert	endp
end